unit ImgFilter;

{$IMPORTEDDATA OFF}

interface

uses NLib;

type
  TImgInfo = record
    Width: Cardinal;
    Height: Cardinal;
    Components: Cardinal;
    Bpp: Cardinal;
    FormatName: string;
    Comment: string;
  end;

  TImgFilterClass = class of TImgFilter;
  TImgFilter = class(TObject)
  protected
    FName: string;
    function Alloc(Size: Cardinal): Pointer;
  public
    constructor Create; virtual;
    function Test(Buf: PChar; BufSize: Cardinal): Boolean; virtual; abstract;
    procedure Decode(InBuf: PChar; InBufSize: Cardinal; var OutBuf: PChar;
      var OutBufSize: Cardinal; var ImgInfo: TImgInfo); virtual; abstract;
    property Name: string read FName;
  end;

  EImgFilterError = class(EError);

implementation

uses Windows;

constructor TImgFilter.Create;
begin
end;

function TImgFilter.Alloc(Size: Cardinal): Pointer;
begin
  // If Delphi's memory manager returned splitted memory block,
  // SetDIBitsToDevice() may fail. So use GlobalAlloc().
  Result := Pointer(GlobalAlloc(GPTR, Size));
end;

end.
